package cn.iocoder.yudao.module.mes.service.stockindetail;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.mes.controller.admin.stockindetail.vo.StockInDetailPageReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.stockindetail.vo.StockInDetailSaveReqVO;
import cn.iocoder.yudao.module.mes.dal.dataobject.stockindetail.StockInDetailDO;

import javax.validation.Valid;
import java.math.BigDecimal;

/**
 * 生产入库分配明细 Service 接口
 *
 * @author 内蒙必硕
 */
public interface StockInDetailService {

    /**
     * 创建生产入库分配明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createStockInDetail(@Valid StockInDetailSaveReqVO createReqVO);

    /**
     * 更新生产入库分配明细
     *
     * @param updateReqVO 更新信息
     */
    void updateStockInDetail(@Valid StockInDetailSaveReqVO updateReqVO);

    /**
     * 删除生产入库分配明细
     *
     * @param id 编号
     */
    void deleteStockInDetail(Long id);

    /**
     * 获得生产入库分配明细
     *
     * @param id 编号
     * @return 生产入库分配明细
     */
    StockInDetailDO getStockInDetail(Long id);

    /**
     * 获得生产入库分配明细分页
     *
     * @param pageReqVO 分页查询
     * @return 生产入库分配明细分页
     */
    PageResult<StockInDetailDO> getStockInDetailPage(StockInDetailPageReqVO pageReqVO);
    BigDecimal selectSumBy(Long planId);
    BigDecimal selectSumByTaskDetailId(Long taskDetailId);


    /**
     * 更新生产入库单的状态
     *
     * @param id 编号
     * @param status 状态
     */
    void updateStockInStatus(Long id, Integer status);

}